Kw <- 2.39e-14
Kc <- 2.45e-11
K3 <- 5.76e-11
KH <- 1.77e-7
AF <- 21/66500 # fixed negatives
AH <- 16/66500 # Histidines
KA <- 10^-6.8

Wats <- function(SID,Pi,Alb,PCO2){
ff<- function(H,SID,Pi,Alb,PCO2)
SID+H-Kw/H - Kc*PCO2/H-2*K3*Kc*PCO2/H^2-
Pi*(1+KA/(KA+H))-Alb*AF+H*Alb*AH/(KH+H)
uniroot(ff,c(0,1),tol=1e-38,maxiter=1000,SID=SID,Pi=Pi,Alb=Alb,PCO2=PCO2)$root}

#SIDC individual concentrations, charges in Z
Wats_corr <- function(SIDC,Z,P,Alb,PCO2){
if( P > 0.02)
stop("P > than 20 mM, Davies suspect")

getcoeff <- function(SIDC,Z,P,PCO2) {
(ISt <- 0.5*sum(SIDC*Z^2))   #

acoeff <- 10^(-0.5213*Z^2*(sqrt(ISt)/(1+sqrt(ISt))-0.2*ISt))
SIDk <- SIDC[-c(7,8)]*acoeff[-c(7,8)]*Z[-c(7,8)] #added [-c(7,8)]
SIDn <- SIDC[-c(7,8)]*Z[-c(7,8)]
out <- list(SIDc=sum(SIDk),SIDn=sum(SIDn),acti = acoeff, ionic_strength = ISt)
out}

ss <- getcoeff(SIDC,Z,P,PCO2)
SID <- ss$SIDc
p <- P*max(ss$acti)

 ff<- function(H,SID,P,Alb,PCO2)
SID+H-Kw/H - max(ss$acti)*Kc*PCO2/H-min(ss$acti)*2*K3*Kc*PCO2/H^2-
P*(1+KA/(KA+H))-Alb*AF+H*Alb*AH/(KH+H)
uniroot(ff,c(0,1),tol=1e-38,maxiter=1000,SID=SID,P=P,Alb=Alb,PCO2=PCO2)$root}

