#Put all files including "Inputframe" in the same directory say "C:/PLOSONE"
#open R - and in the console issue
# source("C:/PLOSONE/getall,r",chdir=TRUE)
(WD <- getwd())
setwd(WD)
windows(record=TRUE,restoreC=TRUE)
sink("acid.txt")
cat("this is getall.r","\n","xxxxxxxxxxxxxxxxxxxxxxxxxxx","\n")
#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# SIMPLE ANALYSIS OF ADDITIVITY OF PROTONS
#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
kw <- 1e-14
HSID <- function(SID) -SID/2 + sqrt((SID/2)^2+kw)

#How can we show in general the fact that protons are not additive
set.seed=1234
SID1 <- runif(100,-3,3)*1e-3
SID2 <- runif(100,-3,3)*1e-3
mSID <- 0.5*(SID1+SID2)
pH1 <- -log10(HSID(SID1))
pH2 <- -log10(HSID(SID2))
mpH <- -log10(HSID(mSID))

H1 <- (HSID(SID1))
H2 <- (HSID(SID2))
mH <- (HSID(mSID))
Hm <- 0.5*(H1+H2)

Hexp <- data.frame(Hmixt=mH,meanH = Hm)


library(ggplot2)
source("mytheme.r")
S <- ggplot(Hexp,aes(x=Hmixt,y=meanH))+geom_point(pch=19,size=1.5,colour="black")
S
SS <- S+geom_segment(aes(x=0,y=0,xend=0.002755797,yend=0.002755797),lwd=.5,colour="blue")
ST <- SS + xlab(expression(paste("[",H^"+","] of mixture"))) +
ylab(expression(paste("Mean [",H^"+","] of two fluids")))
ST <- ST + mytheme
ST
ggsave(file="Fig1.eps")

pHm <- 0.5*(pH1+pH2)

pHexp <- data.frame(pHmixt = mpH, meanpH = pHm)
K <- ggplot(pHexp,aes(x=pHmixt,y=meanpH))+geom_point(pch=19,size=1.5,colour="black")
K
KK <- K +geom_segment(aes(x=2.5,y=2.5,xend=12,yend=12),lwd=.5,colour="blue")
KS <- KK + xlab("pH in mixture") +
ylab("mean pH")
KS + mytheme
ggsave(file="Fig2.eps")


#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
# EMPIRIC RESULTS FROM ICU
#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
library(nlme)
INPUT <- read.table("Inputframe",h=T)
IDLIST <- unique(INPUT$ID)
source("WATS.R")
#We let electrolytes and lacate contribute to ion strength - calculate
#bicarb from pH and PCO2
#first we make a vector SIDC
#the charge vector Z is fixed
Z <- c(-1,2,-1,1,2,1,-1,-1.8)   #last elements are BIC and phosphate - need to be taken out for SID in Wats
pHs <- pHc <- NULL
for (i in 1:length(INPUT[,1])) {

 #i <- 1
(P <-  INPUT$P[i]) #0.00229259 for i <- 1
(PCO2 <-  INPUT$PCO2[i])
(Alb <-  INPUT$ALB[i])
(BIC <- Kc*PCO2/10^-INPUT$pH[i])
(PCHAR <- P*(1+KA/(KA+10^-INPUT$pH[i]))) #0.004133332 for i = 1
(SIDC <- unlist(INPUT[i,c(2,6,7,8,9,10)])*c(1e-3,0.5,1e-3,1e-3,0.5,1e-3))  #Ca Mg already charges - need to go
(SIDC <- c(SIDC,BIC,P))
 (pHc[i] <- -log10(Wats_corr(SIDC,Z,P,Alb,PCO2)))  #7.519849 for i <- 1
(SID  <- sum(SIDC[-c(7,8)]*Z[-c(7,8)]))
(pHs[i] <- -log10(Wats(SID,P,Alb,PCO2)))           #7.584385 for i<- 1
}
INPUT$pHc <- pHc
INPUT$pHe <- pHs

summary(z1 <- lme(pHc~pH,random=~1|ID,INPUT))
#                Value  Std.Error   DF  t-value p-value
#(Intercept) 0.0155895 0.10946222 2360  0.14242  0.8868
#pH          0.9951663 0.01481372 2360 67.17867  0.0000


summary(z1a <- lme(pHe~pH,random=~1|ID,INPUT))

source("mytheme.r")
gg <- ggplot(INPUT,aes(x=pH,y=pHe))+xlim(c(6.8,7.8))+ylim(c(6.8,7.8))+geom_point(pch=19,size=1)+
ylab(c("Modeled pH"))+xlab(c("Measured pH"))
gg
gy <- gg+ geom_segment(aes(x = 6.9, y = 6.9, xend = 7.7, yend = 7.7), colour = "red",size=1.0)
gy
gt <- gy +geom_segment(aes(x = 7, y = 7.096553, xend = 7.6, yend = 7.642062), colour = "blue",size=1.0)
gt
gt + mytheme + theme(legend.position="non")
ggsave("Fig3.eps")

fd <- function(x) 0.7322802 + 0.9091818*x
fd(c(7,7.6)) #7.096553 7.642062

hh <- ggplot(INPUT,aes(x=pH,y=pHc))+xlim(c(6.8,7.8))+ylim(c(6.8,7.8))+geom_point(pch=19,size=1)+
ylab(c("Modeled pH, corrected a.m. Davies"))+xlab(c("Measured pH"))
hh
hy <- hh+ geom_segment(aes(x = 6.9, y = 6.9, xend = 7.7, yend = 7.7), colour = "red",size=1.0)
hy
hg <- hy +geom_segment(aes(x = 7, y = 6.981754, xend = 7.7, yend = 7.678370), colour = "blue",size=1.0)
hg
hg + mytheme + theme(legend.position="non")
ggsave("Fig4.eps")
mm <- function(PH) 0.0155895 +  0.9951663*PH
mm(c(7,7.7))  #6.981754 7.678370

#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

                      # SENSITIVITY ANALYSIS
#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

ff<- function(H,SID,Pi,Alb,PCO2)
SID+H-Kw/H - Kc*PCO2/H-2*K3*Kc*PCO2/H^2-
Pi*(1+KA/(KA+H))-Alb*AF+H*Alb*AH/(KH+H)


DEV <- NULL
for (k in 1:length(INPUT[,1])) {
DEV[k] <- ff(H=10^-INPUT$pHe[k],SID=INPUT$SID[k],Pi=INPUT$P[k],Alb=INPUT$ALB[k],
PCO2=INPUT$PCO2[k])}
summary(DEV)
#very close to zero

DEV_H <- NULL
for (k in 1:length(INPUT[,1])) {
DEV_H[k] <- ff(H=10^-INPUT$pHe[k]+0.1*10^-INPUT$pHe[k],SID=INPUT$SID[k],Pi=INPUT$P[k],Alb=INPUT$ALB[k],
PCO2=INPUT$PCO2[k])}
summary(DEV_H)

DEV_SID <- NULL
for (k in 1:length(INPUT[,1])) {
DEV_SID[k] <- ff(H=10^-INPUT$pHe[k],SID=INPUT$SID[k]+0.1*INPUT$SID[k],Pi=INPUT$P[k],Alb=INPUT$ALB[k],
PCO2=INPUT$PCO2[k])}
summary(DEV_SID)

DEV_CO2 <- NULL
for (k in 1:length(INPUT[,1])) {
DEV_CO2[k] <- ff(H=10^-INPUT$pHe[k],SID=INPUT$SID[k],Pi=INPUT$P[k],Alb=INPUT$ALB[k],
PCO2=INPUT$PCO2[k]-0.1*INPUT$PCO2[k])}
summary(DEV_CO2)

DEV_ALB <- NULL
for (k in 1:length(INPUT[,1])) {
DEV_ALB[k] <- ff(H=10^-INPUT$pHe[k],SID=INPUT$SID[k],Pi=INPUT$P[k],Alb=INPUT$ALB[k]-
0.1*INPUT$ALB[k],PCO2=INPUT$PCO2[k])}
summary(DEV_ALB)

#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

#                          FIND WEAK ACIDS AND BASES TO MAKE PERFECT FIT

#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

Wats1 <- function(SID,Pi,Alb,PCO2,pH){
H <- 10^-pH
ff<- function(H,SID,Pi,Alb,PCO2,UK)
SID+H-Kw/H - Kc*PCO2/H-2*K3*Kc*PCO2/H^2-
Pi*(1+KA/(KA+H))-Alb*AF+H*Alb*AH/(KH+H)- UK*KA2/(H+KA2)
uniroot(ff,c(-10,10),tol=1e-38,maxiter=1000,SID=SID,Pi=Pi,Alb=Alb,PCO2=PCO2,H=H)$f.root
uniroot(ff,c(-10,10),tol=1e-38,maxiter=1000,SID=SID,Pi=Pi,Alb=Alb,PCO2=PCO2,H=H)$root}

Wats2 <- function(SID,Pi,Alb,PCO2,pH){
H <- 10^-pH
ff<- function(H,SID,Pi,Alb,PCO2,UKbas)
SID+H-Kw/H - Kc*PCO2/H-2*K3*Kc*PCO2/H^2-
Pi*(1+KA/(KA+H))-Alb*AF+H*Alb*AH/(KH+H)+ UKbas*KB*H/(H*KB+Kw)
uniroot(ff,c(-10,10),tol=1e-38,maxiter=1000,SID=SID,Pi=Pi,Alb=Alb,PCO2=PCO2,H=H)$root}

UK <- UKbas <- rep(0,length(INPUT[,1]))
KA2 <- 1e-7
KB <- 1e-6
for (k in 1:length(INPUT[,1])) {
UK[k] <- (Wats1(INPUT$SID[k],INPUT$P[k],INPUT$ALB[k],
INPUT$PCO2[k],INPUT$pH[k]))
if(UK[k]<0) { UK[k] <- 0
UKbas[k] <- (Wats2(INPUT$SID[k],INPUT$P[k],INPUT$ALB[k],
INPUT$PCO2[k],INPUT$pH[k]))}
}

summary(UK)
#Min.  1st Qu.   Median     Mean  3rd Qu.     Max.
#0.000000 0.003068 0.006337 0.006624 0.009608 0.028120

sum(as.numeric(UK>0)) #2183

#so lets see if we employ a fixed weak acid with concentration 0.006 and KA2 1e-7

fa<- function(H,SID,Pi,Alb,PCO2,UK)
SID+H-Kw/H - Kc*PCO2/H-2*K3*Kc*PCO2/H^2-
Pi*(1+KA/(KA+H))-Alb*AF+H*Alb*AH/(KH+H)- UK*KA2/(H+KA2)

pHa <- NULL
for (k in  1:length(INPUT[,1])) {
pHa[k] <- -log10(uniroot(fa,c(1e-10,1e-3),tol=1e-38,maxiter=1000,SID=INPUT$SID[k],Pi=INPUT$P[k],
Alb=INPUT$ALB[k],PCO2=INPUT$PCO2[k],UK = 0.006)$root)}

INPUT$pHa <- pHa


pp <- ggplot(INPUT,aes(x=pH,y=pHa))+geom_point(pch=019,size=.8)+xlim(c(6.8,7.8))+
ylim(c(6.8,7.8))+ geom_segment(aes(x = 6.9, y = 6.9, xend = 7.7, yend = 7.7), colour = "red",size=1.5)
#geom_abline(intercept = 0, slope = 1)
pp + ylab("Modeled pH")+ mytheme + theme(legend.position="none")+
#geom_smooth ( method = "lm",se=FALSE,size=2 )+
geom_segment(aes(x = 7, y = 7.0223, xend = 7.6, yend = 7.5716), colour = "blue",size=1.5)
#geom_segment(aes(x = 7, y = 7.0073, xend = 7.6, yend = 7.5946), colour = "blue",size=1.0)

ggsave(file="fig8.eps")

PHA <- function(PH) 0.61469+0.91538*PH
PHA(c(7,7.6)) #7.0223 7.5716
PHF <- function(PH) 0.15623+0.97873*PH
PHF(c(7,7.6)) #7.0073 7.5946

summary(zz<- lme(pHa~pH,random=~1|ID,data=INPUT))
summary(zy<- gls(pHa~pH,data=INPUT))

#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

#    PRECISION AND BLAND-ALTMAN
#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
IDLIST <- unique(INPUT$ID)

INPUT$diffpH <- INPUT$pHe-INPUT$pH
mean(INPUT$diffpH)
DIF <- aggregate(INPUT[17],INPUT[13],mean)$diffpH
SD  <- aggregate(INPUT[17],INPUT[13],sd)$diffpH
LENGTH <- as.numeric(table(INPUT$ID))
MNN <- data.frame(ID = IDLIST,DIF=DIF,SD=SD,LENGTH=LENGTH, VAR=SD^2)

mean(INPUT$diffpH)  #0.06910891
sd(INPUT$diffpH)    #0.07193806

M <- ggplot(MNN,aes(x=DIF,y=SD,size=LENGTH))+
geom_point(shape=21,colour="black",fill="red")
M
MM<- M+scale_size_area(max_size=7)+xlab(c("Estimated - measured pH"))+
ylab(c("Standard deviation of differences"))
MM <- MM + mytheme +theme(legend.position="right")
MM
ggsave("Fig7.eps")

#Make correct Bland-Altman
INP <- INPUT[,c(4,15,13)]


as.vector(table(INPUT$ID))
REP <- NULL
for (i in 1:length(unique(INPUT$ID))) REP <- c(REP,1:as.vector(table(INPUT$ID))[i])
INP$REP <- as.factor(REP)

#to get the right format
INN <- INP[-c(3,4)]
#change - make pHe before pH
IG <- data.frame(pHest = INN$pHe, pHmeas = INN$pH)
y <- stack(IG)
str(y)
#duplicate ID and REPS - there we are
item <- rep(INP$ID,2)
repl <- rep(REP,2)
meth <-  y$ind
y    <-  y$values

library(MethComp)

bland <- data.frame(meth=meth,item=item,repl=repl,y=y)
bland <- Meth(bland)
options(digits=5)
BA.est(bland,linked=TRUE)

# Conversion between methods:
#                alpha   beta  sd.pr LoA-lo LoA-up
#To:    From:                                     
#pHest  pHest    0.000  1.000  0.074 -0.147  0.147
#       pHmeas   0.063  1.000  0.076 -0.089  0.215
#pHmeas pHest   -0.063  1.000  0.076 -0.215  0.089
#       pHmeas   0.000  1.000  0.039 -0.078  0.078
#
# Variance components (sd):
#         IxR   MxI   res
#pHest  0.085 0.034 0.052
#pHmeas 0.085 0.034 0.028

(LOA <- 0.063+c(-1,1)*1.96*sqrt(2*0.034^2+0.052^2+0.058^2))
#-0.116423  0.242423

INP$dif <- INP$pHe-INP$pH; INP$mn <- 0.5*(INP$pHe+INP$pH)
mean(INP$dif) #0.06910891 - why exactly is this different from the mean calculated by Bendix??
BA <- ggplot(INP,aes(x=mn,y=dif))+geom_point(pch=19,size=1.5)
BB<- BA +geom_hline(yintercept= 0.063,colour="blue",size=1.5,linetype= 1)+
geom_hline(yintercept= -0.116423,colour="blue",size=1,linetype= 2)+
geom_hline(yintercept= 0.242423,colour="blue",size=1,linetype= 2)
BB
BC <- BB+xlab(c("0.5*(modeled+measured pH)"))+ylab(c("Modeled-measured pH"))
BC + mytheme
ggsave("Fig6.eps")

#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

#                      nonrametric analysis
#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

library(np)
set.seed <- 1000

t.test(INPUT$pH,INPUT$pHc,paired=TRUE)
bw <- npregbw(pHc~pH+ID,regtype="ll",
bwmethod="cv.aic",  gradients=TRUE,data=INPUT)
summary(bw)
plot(bw,bwmplot.error.methods="asymptomatic") #beautiful
# 


model.np <- npreg(pHc~pH+ID,regtype="ll",
bwmethod="cv.aic",  gradients=TRUE,data=INPUT)
summary(model.np)

INPUT$npar <- fitted(model.np)
source("mytheme.r")
gg <- ggplot(INPUT,aes(x=pH,y=pHc))+xlim(c(6.8,7.8))+ylim(c(6.8,7.8))+geom_point(pch=19,size=1)+
ylab(c("Modeled pH"))+xlab(c("Measured pH"))
gg
GG <- ggplot(INPUT,aes(x=pH,y=npar)) + geom_point(pch=19,size=0.3,colour="grey")+
xlim(c(6.8,7.8))+ylim(c(6.8,7.8))
GY <- GG+ geom_segment(aes(x = 6.9, y = 6.9, xend = 7.7, yend = 7.7), colour = "red",size=1.0)
GY
gt <- GY +geom_segment(aes(x = 7, y = 6.961556, xend = 7.6, yend = 7.606561), colour = "blue",size=1.0)+
ylab("Nonparamteric pH estimate")+xlab("Measured pH")

gt + mytheme


ff <- function(PP) - 0.563500 +1.075008*PP
ff(c(7,7.6))  #6.961556 7.606561
#summary(zz <- lm(npar~pH,INPUT))
#(Intercept) -0.563500   0.060987   -9.24   <2e-16 ***
#pH           1.075008   0.008266  130.05   <2e-16 ***

ph.eval<- data.frame(pH=seq(7.0,7.6,length=1000),ID=sample(INPUT$ID,1000,replace=FALSE))
pHcp <- predict(model.np,newdata=ph.eval)
pHw <- seq(7.0,7.6,length=1000)
plot(pHw,pHcp)
abline(0,1)

DF <- data.frame(pH=pHw,pHc=pHcp)

source("mytheme.r")
gg <- ggplot(INPUT,aes(x=pH,y=pHc))+xlim(c(6.8,7.8))+ylim(c(6.8,7.8))+geom_point(pch=19,size=1)+
ylab(c("Modeled pH"))+xlab(c("Measured pH"))
gg
GG <- ggplot(DF,aes(x=pH,y=pHc)) + geom_point(pch=19,size=0.75,colour="black")+
xlim(c(6.8,7.8))+ylim(c(6.8,7.8))
GG
GY <- GG+ geom_segment(aes(x = 6.9, y = 6.9, xend = 7.7, yend = 7.7), colour = "red",size=1.0)
GY
gt <- GY +geom_segment(aes(x = 7, y = 6.98604, xend = 7.7, yend = 7.68764), colour = "blue",size=1.0)+
ylab("Nonparamteric pH prediction")+xlab("Measured pH")

gt
gt + mytheme + theme(legend.position="non")
ggsave("Fig5.eps") 
options(digits=9)
summary(lm(pHc~pH,data=DF))

#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#
#                          FIND LACKING SID TO MAKE FIT EXACT
#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

ff<- function(H,SID,Pi,Alb,PCO2){
SID+H-Kw/H - Kc*PCO2/H-2*K3*Kc*PCO2/H^2-
Pi*(1+KA/(KA+H))-Alb*AF+H*Alb*AH/(KH+H) }


TSID <- dSID  <- rep(0,length(INPUT[,1]))

for (k in 1:length(INPUT[,1])) {
TSID[k] <- uniroot(ff,c(-1,1),tol=1e-38,maxiter=1000,H=10^-INPUT$pH[k],
Pi=INPUT$P[k],Alb=INPUT$ALB[k],PCO2=INPUT$PCO2[k])$root
dSID[k] <- TSID[k]-INPUT$SID[k]
 }
summary(dSID)
quantile(dSID,probs=c(0.025,0.5,0.975))
mean(dSID)+c(-1,1)*1.96*sd(dSID)
INPUT$dSID <- dSID
range(dSID)

#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
#           MAKE PLOTS OF TIME COURSES
#XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cat("\n","Plots of time courses are in first.pdf and second.pdf","\n",
file="Results.txt",append=TRUE)
#Make plots of time courses

i <- which(IDLIST=="PTID18546-5756");i
j <- which(IDLIST=="PTID52258-16805");j


Sys.setlocale("LC_TIME", "USA") #to get the Months names right
INP <- subset(INPUT,ID==IDLIST[i])

library(ggplot2)

predicts <- data.frame(times=as.POSIXlt(INP$times,origin="1970-1-1"),pH=INP$pHe)
pp <- ggplot(INP,aes(x=as.POSIXlt(times,origin="1970-1-1"),y= pH))+geom_point()
ppp <- pp + theme_bw()+xlab("")+ylab("pH measured and fitted (red line)") + geom_line(data=predicts,col="red") 
ppp + mytheme
ggsave("Fig9.eps")

Sys.setlocale("LC_TIME", "USA") #to get the Months names right
INP <- subset(INPUT,ID==IDLIST[j])
predicts <- data.frame(times=as.POSIXlt(INP$times,origin="1970-1-1"),pH=INP$pHe)
pp <- ggplot(INP,aes(x=as.POSIXlt(times,origin="1970-1-1"),y= pH))+geom_point()
ppp <- pp + theme_bw()+xlab("")+ylab("pH measured and fitted (red line)") + geom_line(data=predicts,col="red") 
ppp + mytheme
ggsave("Fig10.eps")
unlink("acid.txt")

                   